from app.libraries.database import Database
from app.libraries.setup import Setup
from mastodon import Mastodon
import os
import sys

if __name__ == '__main__':

    db = Database()

    setup = Setup()

    mastodon = Mastodon(
        access_token = setup.mastodon_app_token,
        api_base_url= setup.mastodon_hostname
        )

    topten_servers, topten_versions, mast_servers = db.get_versions()

    toot_text = f'\nTotal alive Mastodon servers: {str(mast_servers)}\n\n'

    toot_text += f'Top ten most used Mastodon versions: \n\n'

    i = 0

    while i < 10:

        toot_text += f'{str(i+1)} - v{topten_versions[i]} -> {str(topten_servers[i])} ({str(round(((topten_servers[i] * 100) / mast_servers), 2))}%)\n'
        i += 1

    toot_text += '\n#Mastodon'

    print(toot_text)

    mastodon.status_post(toot_text, in_reply_to_id=None, )
